From 6541ffbb0ec7b081aee87fb64f6ff681b3ea7361 Mon Sep 17 00:00:00 2001
From: Meghan Richardson <mrichard@fedoraproject.org>
Date: Jul 07 2015 18:06:40 +0000
Subject: [PATCH 164/1001] Merge branch 'develop' of pagure.io:fedora-hubs into develop


---

diff --git a/.gitignore b/.gitignore
index 7b3bc0e..d042055 100644
--- a/.gitignore
+++ b/.gitignore
@@ -2,3 +2,4 @@
 *.egg*
 fedmsg.d/fas_credentials.py
 node*
+build/
diff --git a/hubs/app.py b/hubs/app.py
index f5262d4..bca015e 100644
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -5,6 +5,7 @@ import os
 import flask
 import flask.json
 import munch
+import six
 
 from flask.ext.openid import OpenID
 
@@ -184,7 +185,10 @@ def check_auth():
     flask.g.fedmsg_config = fedmsg_config
     flask.g.auth = munch.Munch(logged_in=False)
     if 'openid' in flask.session:
-        openid = flask.session.get('openid').strip('/').split('/')[-1]
+        openid = flask.session.get('openid')
+        if isinstance(openid, six.binary_type):
+            openid = openid.decode('utf-8')
+        openid = openid.strip('/').split('/')[-1]
         flask.g.auth.logged_in = True
         flask.g.auth.openid = openid
         flask.g.auth.user = hubs.models.User.by_openid(session, openid)
@@ -222,7 +226,49 @@ def get_widget(session, hub, idx):
     flask.abort(404)
 
 
-
+## Here are a bunch of API methods that should probably be broken out into
+## their own file
+@app.route('/api/hub/<hub>/subscribe', methods=['POST'])
+@login_required
+def hub_subscribe(hub):
+    hub = get_hub(session, hub)
+    user = hubs.models.User.by_openid(session, flask.g.auth.openid)
+    hub.subscribe(session, user)
+    session.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
+
+@app.route('/api/hub/<hub>/unsubscribe', methods=['POST'])
+@login_required
+def hub_unsubscribe(hub):
+    hub = get_hub(session, hub)
+    user = hubs.models.User.by_openid(session, flask.g.auth.openid)
+    try:
+        hub.unsubscribe(session, user)
+    except KeyError:
+        return flask.abort(400)
+    session.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
+
+@app.route('/api/hub/<hub>/join', methods=['POST'])
+@login_required
+def hub_join(hub):
+    hub = get_hub(session, hub)
+    user = hubs.models.User.by_openid(session, flask.g.auth.openid)
+    hub.subscribe(session, user, role='member')
+    session.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
+
+@app.route('/api/hub/<hub>/leave', methods=['POST'])
+@login_required
+def hub_leave(hub):
+    hub = get_hub(session, hub)
+    user = hubs.models.User.by_openid(session, flask.g.auth.openid)
+    try:
+        hub.unsubscribe(session, user, role='member')
+    except KeyError:
+        return flask.abort(400)
+    session.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
 
 
 if __name__ == '__main__':
diff --git a/hubs/defaults.py b/hubs/defaults.py
index 80f4520..ce29c74 100644
--- a/hubs/defaults.py
+++ b/hubs/defaults.py
@@ -12,49 +12,43 @@ def add_user_widgets(session, hub, username, fullname):
         }))
     hub.widgets.append(widget)
 
-    ## The feed widget works, but it needs to be cleaned up lots before we
-    ## throw it in by default.
-    #widget = hubs.models.Widget(
-    #    plugin='feed', index=1, left=True,
-    #    _config=json.dumps({
-    #        'username': username,
-    #        'fmn_context': 'irc',  # TODO -- make this 'hubs'
-    #    }))
-    #hub.widgets.append(widget)
-
-    # Right Side Widgets
+    # The feed widget works, but it needs to be cleaned up lots before we
+    # throw it in by default.
     widget = hubs.models.Widget(
-        plugin='avatar', index=0,
+        plugin='feed', index=1, left=True,
         _config=json.dumps({
             'username': username,
+            'fmn_context': 'irc',  # TODO -- make this 'hubs'
         }))
     hub.widgets.append(widget)
+
+    # Right Side Widgets
     widget = hubs.models.Widget(
-        plugin='fedmsgstats', index=1,
+        plugin='fedmsgstats', index=0,
         _config=json.dumps({
             'username': username,
         }))
     hub.widgets.append(widget)
     widget = hubs.models.Widget(
-        plugin='workflow.updates2stable', index=2,
+        plugin='workflow.updates2stable', index=1,
         _config=json.dumps({
             'username': username,
         }))
     hub.widgets.append(widget)
     widget = hubs.models.Widget(
-        plugin='workflow.pendingacls', index=3,
+        plugin='workflow.pendingacls', index=2,
         _config=json.dumps({
             'username': username,
         }))
     hub.widgets.append(widget)
     widget = hubs.models.Widget(
-        plugin='subscriptions', index=4,
+        plugin='subscriptions', index=3,
         _config=json.dumps({
             'username': username,
         }))
     hub.widgets.append(widget)
     widget = hubs.models.Widget(
-        plugin='badges', index=5,
+        plugin='badges', index=4,
         _config=json.dumps({
             'username': username,
         }))
diff --git a/hubs/models.py b/hubs/models.py
index 9933dd6..ff117ab 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -24,7 +24,6 @@
 import datetime
 import json
 import logging
-import random
 
 import sqlalchemy as sa
 from sqlalchemy import create_engine
@@ -101,6 +100,14 @@ class Association(BASE):
     user = relation("User", backref="associations")
     hub = relation("Hub", backref="associations")
 
+    @classmethod
+    def get(cls, session, hub, user, role):
+        return session.query(cls)\
+            .filter_by(hub=hub)\
+            .filter_by(user=user)\
+            .filter_by(role=role)\
+            .first()
+
 
 class Hub(BASE):
     __tablename__ = 'hubs'
@@ -137,6 +144,18 @@ class Hub(BASE):
         session.add(Association(user=user, hub=self, role=role))
         session.commit()
 
+    def unsubscribe(self, session, user, role='subscriber'):
+        """ Subscribe a user to this hub. """
+        # TODO -- add logic here to manage not adding the user multiple
+        # times, doing different roles, etc.. publish a fedmsg message,
+        # etc...
+        association = Association.get(session, hub=self, user=user, role=role)
+        if not association:
+            raise KeyError("%r is not a %r of %r" % (user, role, self))
+        session.delete(association)
+        session.commit()
+
+
     @classmethod
     def by_name(cls, session, name):
         return session.query(cls).filter_by(name=name).first()
diff --git a/hubs/widgets/stats.py b/hubs/widgets/stats.py
index 67a0e26..3f77a47 100644
--- a/hubs/widgets/stats.py
+++ b/hubs/widgets/stats.py
@@ -1,6 +1,7 @@
 from hubs.hinting import hint, prefixed as _
 from hubs.widgets.chrome import panel
 
+import flask
 import jinja2
 
 chrome = panel()
@@ -10,16 +11,29 @@ template = jinja2.Template("""
     <tr><th>Members</th><th>Subscribers</th></tr>
     <tr class="text-info"><td>{{members | length}}</td><td>{{subscribers | length}}</td></tr>
   </table>
+
   {% if g.auth.logged_in %}
+    <div class="pull-right">
     {% if g.auth.nickname in members %}
-    <div class="pull-right"><button class="btn btn-danger">Resign</button></div>
+    <form action="{{hub_leave_url}}" method="POST">
+        <button class="btn btn-danger">Leave Hub</button>
+    </form>
     {% elif g.auth.nickname in subscribers %}
-    <div class="pull-right"><button class="btn btn-warning">Unsubscribe</button></div>
+    <form action="{{hub_unsubscribe_url}}" method="POST">
+        <button class="btn btn-warning">Unsubscribe</button>
+    </form>
     {% else %}
-    <div class="pull-right"><button class="btn btn-info">Subscribe</button></div>
+    <form action="{{hub_subscribe_url}}" method="POST">
+        <button class="btn btn-info">Subscribe</button>
+    </form>
     {% endif %}
+    </div>
   {% else %}
-    <div class="pull-right"><button class="btn btn-info">Subscribe</button></div>
+    <div class="pull-right">
+        <form action="{{hub_subscribe_url}}" method="POST">
+            <button class="btn btn-info">Subscribe</button>
+        </form>
+    </div>
   {% endif %}
 </div>
 """)
@@ -30,6 +44,10 @@ def data(session, widget):
         owners=[u.username for u in widget.hub.owners],
         members=[u.username for u in widget.hub.members],
         subscribers=[u.username for u in widget.hub.subscribers],
+        hub_leave_url=flask.url_for('hub_leave', hub=widget.hub.name),
+        hub_join_url=flask.url_for('hub_join', hub=widget.hub.name),
+        hub_subscribe_url=flask.url_for('hub_subscribe', hub=widget.hub.name),
+        hub_unsubscribe_url=flask.url_for('hub_unsubscribe', hub=widget.hub.name),
     )
 
 
diff --git a/populate.py b/populate.py
index 9e02e82..4e5fa75 100755
--- a/populate.py
+++ b/populate.py
@@ -11,7 +11,7 @@ fedmsg_config = fedmsg.config.load_config()
 session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'], True, True)
 
 users = ['mrichard', 'duffy', 'ryanlerch', 'gnokii', 'nask0',
-         'abompard', 'decause', 'ralph']
+         'abompard', 'decause', 'ralph', 'lmacken']
 for username in users:
     fullname = 'Full Name Goes Here'
     openid = '%s.id.fedoraproject.org' % username
@@ -46,7 +46,7 @@ hub.widgets.append(widget)
 
 widget = hubs.models.Widget(plugin='sticky', index=0, left=True,
                             _config=json.dumps({
-                                'text': 'This is a sticky note.',
+                                'text': "The Design Team is the design group of the Fedora project. Our interests are not only in creating graphics for use by the Fedora community, but also in advocating the use of the creative tools that are a part of Fedora.",
                             }))
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='dummy', index=1, left=True)
@@ -87,7 +87,7 @@ hub.widgets.append(widget)
 
 widget = hubs.models.Widget(plugin='sticky', index=0, left=True,
                             _config=json.dumps({
-                                'text': 'This is a sticky note.',
+                                'text': "The Infrastructure Team consists of dedicated volunteers and professionals managing the servers, building the tools and utilities, and creating new applications to make Fedora development a smoother process. We're located all over the globe and communicate primarily by IRC and e-mail. ",
                             }))
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='dummy', index=1, left=True)
@@ -96,6 +96,7 @@ hub.widgets.append(widget)
 
 hub.subscribe(session, hubs.models.User.by_openid(session, 'ralph.id.fedoraproject.org'), 'owner')
 hub.subscribe(session, hubs.models.User.by_openid(session, 'abompard.id.fedoraproject.org'), 'owner')
+hub.subscribe(session, hubs.models.User.by_openid(session, 'lmacken.id.fedoraproject.org'), 'owner')
 hub.subscribe(session, hubs.models.User.by_openid(session, 'nask0.id.fedoraproject.org'), 'member')
 hub.subscribe(session, hubs.models.User.by_openid(session, 'decause.id.fedoraproject.org'), 'subscriber')
 
